--- postgresql.spec.prev	Sun Sep 30 22:27:08 2001
+++ postgresql.spec	Mon Oct  1 00:54:19 2001
@@ -43,7 +43,7 @@
 # Pre-release RPM's should not be put up on the public ftp.postgresql.org server
 # -- only test releases or full releases should be.
 
-Release: 1pe
+Release: 2pe
 License: BSD
 Group: Applications/Databases
 Source0: ftp://ftp.postgresql.org/pub/source/v%{version}/postgresql-%{version}.tar.gz
@@ -171,10 +171,10 @@
 %package contrib
 Summary: Contributed source and binaries distributed with PostgreSQL
 Group: Applications/Databases
-Requires: libpq.so postgresql = %{version}
+Requires: postgresql = %{version} postgresql-perl postgresql-tcl tk
 %description contrib
-The postgresql-contrib package includes the contrib tree distributed with
-the PostgreSQL tarball.  Selected contrib modules are prebuilt.
+The postgresql-contrib package contains contributed packages that are
+included in the PostgreSQL distribution.
 
 %description server
 The postgresql-server package includes the programs needed to create
@@ -368,6 +368,7 @@
 	--datadir=/usr/share/pgsql
 
 make all
+make -C contrib all
 
 %if %test
 	pushd src/test
@@ -379,6 +380,7 @@
 rm -rf $RPM_BUILD_ROOT
 
 make DESTDIR=$RPM_BUILD_ROOT install
+make -C contrib DESTDIR=$RPM_BUILD_ROOT install
 
 %if %perl
 	make PREFIX=$RPM_BUILD_ROOT/usr -C src/interfaces/perl5 -f Makefile install
@@ -506,108 +508,6 @@
 cp %{SOURCE6} README.rpm-dist
 mv $RPM_BUILD_ROOT%{_docdir}/postgresql/html doc
 
-# Build contrib stuff....
-pushd contrib
-make clean
-make all
-popd 
-# move the contrib tree to the right place after building....
-cp -r contrib $RPM_BUILD_ROOT/usr/lib/pgsql
-# We'll do more prep work in a later release.....
-
-#more massaging
-
-pushd $RPM_BUILD_ROOT/usr/lib/pgsql/contrib
-
-# Get rid of useless makefiles
-rm -f Makefile */Makefile
-# earthdistance
-pushd earthdistance
-perl -pi -e "s|/usr/share/pgsql/contrib|/usr/lib/pgsql/contrib/earthdistance|" *
-popd
-
-# array
-pushd array
-perl -pi -e "s|/usr/lib/contrib|/usr/lib/pgsql/contrib/array|" *
-popd
-
-# cube
-pushd cube
-perl -pi -e "s|/usr/lib/contrib|/usr/lib/pgsql/contrib/cube|" cube.sql
-popd
-
-# fulltext
-pushd fulltextindex
-perl -pi -e "s|/usr/lib/contrib|/usr/lib/pgsql/contrib/fulltextindex|" *.sql
-popd
-
-# intarray
-pushd intarray
-perl -pi -e "s|/usr/lib/contrib|/usr/lib/pgsql/contrib/intarray|" *.sql
-popd
-
-# isbn_issn
-pushd isbn_issn
-perl -pi -e "s|/usr/lib/contrib|/usr/lib/pgsql/contrib/isbn_issn|" *.sql
-popd
-
-# lo
-pushd lo
-perl -pi -e "s|/usr/lib/contrib|/usr/lib/pgsql/contrib/lo|" *.sql
-popd
-
-# miscutil
-pushd miscutil
-perl -pi -e "s|/usr/lib/contrib|/usr/lib/pgsql/contrib/miscutil|" *.sql
-popd
-
-# noup
-pushd noupdate
-perl -pi -e "s|/usr/lib/contrib|/usr/lib/pgsql/contrib/noupdate|" *.sql
-popd
-
-# pgcrypto
-pushd pgcrypto
-perl -pi -e "s|/usr/lib/contrib|/usr/lib/pgsql/contrib/pgcrypto|" *.sql
-popd
-
-
-# rserv
-pushd rserv
-perl -pi -e "s|/usr/share/|/usr/lib/|" *
-perl -pi -e "s|/usr/lib/contrib|/usr/lib/pgsql/contrib/rserv|" *
-perl -pi -e "s|/usr/bin|/usr/lib/pgsql/contrib/rserv|" *
-perl -pi -e "s|/usr/lib/pgsql/contrib\"|/usr/lib/pgsql/contrib/rserv\"|" *
-perl -pi -e "s|/usr/lib/pgsql/contrib$|/usr/lib/pgsql/contrib/rserv|" *
-popd
-
-# seg 
-pushd seg
-perl -pi -e "s|/usr/lib/contrib|/usr/lib/pgsql/contrib/seg|" *.sql
-popd
-
-# spi
-pushd spi
-perl -pi -e "s|/usr/lib/contrib|/usr/lib/pgsql/contrib/spi|" *.sql
-popd
-
-# string
-pushd string
-perl -pi -e "s|/usr/lib/contrib|/usr/lib/pgsql/contrib/string|" *.sql
-popd
-
-# userlock
-pushd userlock
-perl -pi -e "s|/usr/lib/contrib|/usr/lib/pgsql/contrib/userlock|" *.sql
-popd
-
-popd
-
-#more broken symlinks
-rm -f $RPM_BUILD_ROOT/usr/lib/pgsql/contrib/pg_resetxlog/pg_crc.c $RPM_BUILD_ROOT/usr/lib/pgsql/contrib/pg_controldata/pg_crc.c
-cp src/backend/utils/hash/pg_crc.c $RPM_BUILD_ROOT/usr/lib/pgsql/contrib/pg_resetxlog/pg_crc.c
-ln $RPM_BUILD_ROOT/usr/lib/pgsql/contrib/pg_resetxlog/pg_crc.c $RPM_BUILD_ROOT/usr/lib/pgsql/contrib/pg_controldata/pg_crc.c
-
 # Symlink libpq.so.2.0 to libpq.so.2 for backwards compatibility, until 
 # -soname patches are the norm.
 pushd $RPM_BUILD_ROOT/usr/lib
@@ -729,8 +629,55 @@
 
 %files contrib
 %defattr(-,root,root)
-%dir /usr/lib/pgsql/contrib/
-/usr/lib/pgsql/contrib/*
+/usr/lib/pgsql/_int.so
+/usr/lib/pgsql/array_iterator.so
+/usr/lib/pgsql/autoinc.so
+/usr/lib/pgsql/btree_gist.so
+/usr/lib/pgsql/chkpass.so
+/usr/lib/pgsql/cube.so
+/usr/lib/pgsql/dblink.so
+/usr/lib/pgsql/earthdistance.so
+/usr/lib/pgsql/fti.so
+/usr/lib/pgsql/fuzzystrmatch.so
+/usr/lib/pgsql/insert_username.so
+/usr/lib/pgsql/isbn_issn.so
+/usr/lib/pgsql/lo.so
+/usr/lib/pgsql/misc_utils.so
+/usr/lib/pgsql/moddatetime.so
+/usr/lib/pgsql/noup.so
+/usr/lib/pgsql/pgcrypto.so
+/usr/lib/pgsql/refint.so
+/usr/lib/pgsql/rserv.so
+/usr/lib/pgsql/rtree_gist.so
+/usr/lib/pgsql/seg.so
+/usr/lib/pgsql/string_io.so
+/usr/lib/pgsql/timetravel.so
+/usr/lib/pgsql/user_locks.so
+/usr/share/pgsql/contrib/
+/usr/bin/dbf2pg
+/usr/bin/findoidjoins
+/usr/bin/make_oidjoins_check
+/usr/bin/fti.pl
+/usr/bin/oid2name
+/usr/bin/pg_controldata
+/usr/bin/pg_dumplo
+/usr/bin/pg_logger
+/usr/bin/pg_resetxlog
+/usr/bin/pgbench
+/usr/bin/RservTest
+/usr/bin/MasterInit
+/usr/bin/MasterAddTable
+/usr/bin/Replicate
+/usr/bin/MasterSync
+/usr/bin/CleanLog
+/usr/bin/SlaveInit
+/usr/bin/SlaveAddTable
+/usr/bin/GetSyncID
+/usr/bin/PrepareSnapshot
+/usr/bin/ApplySnapshot
+/usr/bin/InitRservTest
+/usr/bin/vacuumlo
+%doc contrib/*/README.* contrib/spi/*.example
 
 %files libs
 %defattr(-,root,root)
@@ -780,7 +727,6 @@
 /usr/lib/libecpg.so
 /usr/lib/libpq++.so
 /usr/lib/libpgeasy.so
-/usr/lib/libpgtcl.so
 /usr/lib/libpq.a
 /usr/lib/libecpg.a
 /usr/lib/libpq++.a
@@ -792,7 +738,8 @@
 %if %tcl
 %files tcl
 %defattr(-,root,root)
-%attr(755,root,root) /usr/lib/libpgtcl.so.*
+# libpgtcl.so is not in -devel because Tcl scripts may load it by that name.
+/usr/lib/libpgtcl.so*
 /usr/bin/pgtclsh
 %{_mandir}/man1/pgtclsh.1*
 /usr/lib/pgsql/pltcl.so
